田草博客
日志搜索


 标题   内容 评论


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件
-电信用户-|-网通用户-
-博客论坛-|-软件下载-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2018 - 12 48
      1
2345678
9101112131415
16171819202122
23242526272829
3031


站点统计

最新评论



adding-to-autocads-application-menu Creates a new toolbar
未知 CUI添加自定义菜单栏命令   [ 日期:2018-09-15 ]   [ 来自:本站原创 ]  HTML


Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.Customization
Imports System
Imports System.Collections.Specialized
Namespace PartialCUI
    Public Class Commands
        Implements IExtensionApplication
        Public Sub Initialize() Implements IExtensionApplication.Initialize
        End Sub
        Public Sub Terminate() Implements IExtensionApplication.Terminate
        End Sub
        <CommandMethod("M23")> _
        Public Sub BuildMenuCUI()
            Const myCuiFile As String = "c:\kean.cuix"
            Const myCuiFileToSend As String = "c:/kean.cuix"
            Const myCuiSectionName As String = "Kean"
            Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor

            Dim doc As Document = Application.DocumentManager.MdiActiveDocument

            doc.SendStringToExecute("_.cuiunload KEAN ", False, False, False)

            Dim mainCui As String = Application.GetSystemVariable("MENUNAME") + ".cuix"
            Dim cs As New CustomizationSection(mainCui)
            Dim pcfc As PartialCuiFileCollection = cs.PartialCuiFiles
            'If pcfc.Contains(myCuiFile) Then
            '    ed.WriteMessage(vbLf & "Customization file """ + myCuiFile + """ already loaded.")
            'Else
            If System.IO.File.Exists(myCuiFile) Then
                ed.WriteMessage(vbLf & "Customization file """ + myCuiFile + """ exists - loading it.")
                LoadMyCui(myCuiFileToSend)
            Else
                ed.WriteMessage(vbLf & "Customization file """ + myCuiFile + """ does not exist - building it.")
                ' Create a customization section for our partial menu
                Dim pcs As New CustomizationSection()
                pcs.MenuGroupName = myCuiSectionName
                ' Let's add a menu group, with two commands
                Dim mg As New MacroGroup(myCuiSectionName, pcs.MenuGroup)
                Dim mm1 As New MenuMacro(mg, "Cmd 1", "^C^CCmd1", "ID_MyCmd1")
                Dim mm2 As New MenuMacro(mg, "Cmd 2", "^C^CCmd2", "ID_MyCmd2")
                ' Now let's add a pull-down menu, with two items
                Dim sc As New StringCollection()
                sc.Add("POP15")
                Dim pm As New PopMenu(myCuiSectionName, sc, "ID_MyPop1", pcs.MenuGroup)
                Dim pmi1 As New PopMenuItem(mm1, "Pop Cmd 1", pm, -1)
                Dim pmi2 As New PopMenuItem(mm2, "Pop Cmd 2", pm, -1)
                ' Finally we save the file and load it
                pcs.SaveAs(myCuiFile)
                LoadMyCui(myCuiFileToSend)
            End If
            'End If

        End Sub

        Private Sub LoadMyCui(ByVal cuiFile As String)
            Dim doc As Document = Application.DocumentManager.MdiActiveDocument
            Dim oldCmdEcho As Object = Application.GetSystemVariable("CMDECHO")
            Dim oldFileDia As Object = Application.GetSystemVariable("FILEDIA")
            Application.SetSystemVariable("CMDECHO", 0)
            Application.SetSystemVariable("FILEDIA", 0)
            doc.SendStringToExecute("_.cuiunload KEAN ", False, False, False)
            doc.SendStringToExecute("_.cuiload " + cuiFile + " ", False, False, False)
            doc.SendStringToExecute("(setvar ""FILEDIA"" " + oldFileDia.ToString() + ")(princ) ", False, False, False)
            doc.SendStringToExecute("(setvar ""CMDECHO"" " + oldCmdEcho.ToString() + ")(princ) ", False, False, False)
            Application.ReloadAllMenus()
        End Sub
    End Class
End Namespace

http://through-the-interface.typepad.com/throu ... 007/05/creating_a_part.html



[本日志由 tiancao1001 于 2018-09-15 05:52 PM 编辑]


暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:1*4=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
Tiancao Blog All Rights Reserved 田草博客 版权所有
Copyright ©